#ifndef _CHAN_MANAGER_H
#define _CHAN_MANAGER_H

#include <pthread.h>

#define NCHANBUCKETS 256
#define BUFFERSIZE 32768

struct PeerList;
struct InstanceStruct;

struct ChanStruct{
	pthread_mutex_t lock;
	int chid;
	struct PeerList *peer;
	volatile void *volatile rbuffer, *volatile rrPtr, *volatile rwPtr;
	volatile void *volatile sbuffer, *volatile srPtr, *volatile swPtr, *volatile ssPtr;
	struct InstanceStruct *waitingInstance;
	struct InstanceStruct *orgWriter;
	
	struct ChanStruct *next;
};


int ch_init(int workers);

int ch_receive();

int ch_action(struct InstanceStruct *instance);


#endif//_CHAN_MANAGER_H