#ifndef _NETWORK_H
#define _NETWORK_H

#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>

struct PeerList{
	int socket;
	int id;
	char cascade;
	char *rcvBuffer;
	char rPtr, wPtr;
	sem_t rSem, wSem;
	pthread_mutex_t sendLock;
	struct sockaddr_storage *saddr;

	struct PeerList *prev;
	struct PeerList *next;
};


int nw_init(int id, int port, char *mip, char *mpt);
int nw_getNodeId();
int nw_sendFile(int id, char *name);
int nw_chsend(struct PeerList *peer, int chid, volatile void * volatile data, int size);
int nw_spawn(int id, char *name, int *chanTrans, int ctSize);
int nw_close();
int nw_panic();


#endif //_NETWORK_H