#ifndef _TASK_MANAGER_H
#define _TASK_MANAGER_H

struct FunStruct; //Forward from FunctionManager.h

enum InstanceState{NEW = 1, READY = 2, CHANR = 4, CHANW = 8, CHANRNW = 16, CHANWNW = 32, NODEWAIT = 64, TRANSFER = 128, SPAWN = 256, DONE = 512};

struct InstanceStruct{
	struct FunStruct *funStruct;
	void *memPtr;
	int *chanTrans;
	int step;
	enum InstanceState state;
	void *comPtr;
	int comSize;
	int localCh;
	int nodeWait;

	struct InstanceStruct *next, *prev;
};

struct SpawnStruct{
	char *name;
	int *chanTrans;
	int ctSize;
	int peerId;
};


int tm_init(int workers);
int tm_createNew(struct FunStruct *funStruct, int *chanTrans);
int tm_requeue(struct InstanceStruct *instance);


#endif//_TASK_MANAGER_H